/* this is a dumb O(N) storage merge algorithm

   it doesn't attempt any real optimisation 
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <malloc.h>


#ifndef MIN
#define MIN(a,b) ((a)<(b)?(a):(b))
#endif

static int comparisons;

/*******************************************************************
simple merge code - must be fast
no boundary checking is done and the number of elements taken from 
list1 is returned
********************************************************************/
static int SimpleMerge(void *dest,void *src1,void *src2,int n)
#define DOONE(x) (comparisons++, i1<i2?(x = i1,i1= *(++ss1)):(x = i2,i2= *(++ss2)))
{
  register int N = n;
  int *ss1=src1,*ss2=src2,*d=dest;
  int i1= *ss1,i2= *ss2;
  int d0,d1,d2,d3;
  int d4,d5,d6,d7; 

  while (N >= 8)
    {	
      DOONE(d0); DOONE(d1); DOONE(d2); DOONE(d3); 
      DOONE(d4); DOONE(d5); DOONE(d6); DOONE(d7); 
      d[0] = d0;d[1] = d1;d[2] = d2;d[3] = d3;
      d[4] = d4;d[5] = d5;d[6] = d6;d[7] = d7; 
      d+=8;N-=8;
    }

  while (N--)
    DOONE(*d++);

  return(ss1-(int *)src1);
}


/* merge two sorted lists of elements into one list. The two lists are
   assumed to be contiguous with the first starting at data[0] and the
   second starting at data[n1]. The two lists are of length n1 and n2
   respectively */
int dmerge(int *data, int n1, int n2)
{
	int *p = (int *)malloc((n1+n2)*sizeof(int));
	int *d1, *d2, *q;
	int r1, r2, n, m;

	comparisons=0;

	d1 = data;
	d2 = &data[n1];
	q = p;
	r1 = n1;
	r2 = n2;

	while (r1 && r2) {
		n = MIN(r1, r2);
		m = SimpleMerge(q, d1, d2, n);

		r1 -= m;
		r2 -= n-m;
		d1 += m;
		d2 += n-m;
		q += n;
	}

	if (r1) {
		memcpy(q, d1, r1*sizeof(int));
	}

	if (r2) {
		memcpy(q, d2, r2*sizeof(int));
	}


	memcpy(data, p, (n1+n2)*sizeof(int));

	free(p);

	return comparisons;
}
